;;;    XSCALE.LSP / 12.10.2014 / NOKTASAL PROJE LTD STI
;;;    
;;;    Copyright (C) 2014 by HSEYN GREN
;;;  
;;;    NOKTASAL PROJE MUHENDISLIK DANISMANLIK NAAT MMARLIK ETM SAN. VE TC LTD. T.
;;;
;;;    
;;;
;;;
;;;
;;;
;;;
;;;
;;;
;;;
;;;
;;;
;;;
;;;
;;;
 


(defun xscale (sset basp xscale yscale zscale / )
(if (makeblock "*" basp sset xscale yscale zscale 0)
	(command "._explode" (entlast))
)
)


(defun c:xscale (/ oldecho olderr temp xs ys zs basp sset)
	(setq oldecho (getvar "cmdecho") olderr *error*)
	(command "._undo" "_group")
	(defun *error* (msg)
		(setq *error* olderr)
		(princ (strcat "\nXSCALE: " msg "\n"))
		(prin1)
	)
	(setvar "cmdecho" 0)
	(setq basp (while (not temp) (setq temp (getpoint "\nbase point: ")))
			sset (if (< 0 (sslength (setq temp (ssget)))) temp nil)
			xs (if sset (if (not (setq temp (getdist basp "\nX-scale <1>: "))) 1 temp))
			ys (if sset (if (not (setq temp (getdist basp "\nY-scale <1>: "))) 1 temp))
			zs (if sset (if (not (setq temp (getdist basp "\nZ-scale <1>: "))) 1 temp))
	)
	(if (and basp sset xs ys zs)
		(xscale sset basp xs ys zs)
	)
	(command "._undo" "_end")
	(setq *error* olderr)
	(setvar "cmdecho" oldecho)
	(prin1)
)


(defun makeblock (name baspoint sset xs ys zs rot / i e en blocktype)
(if sset nil (setq sset (ssadd)))
(if (or (/= 'STR (type name)) (= "" name)) (setq name "*A"))
(if (= (substr name 1 1) "*") 
	(setq blocktype 1 name "*A") 
	(setq blocktype 0)
)
(entmake (append
	'((0 . "BLOCK"))
	(list (cons 2  name))
	(list (cons 70 blocktype))
	(list (cons 10 baspoint))
))
(setq i -1)
(while (setq e (ssname sset (setq i (1+ i))))
	(cond
		((/= 1 (cdr (assoc 66 (entget e))))
			(if (entget e) (progn
				(entmake (entget e '("*")))
				(entdel e)
			))
		)
		((= 1 (cdr (assoc 66 (entget e))))
			(if (entget e) (progn
				(entmake (entget e '("*")))
				(setq en e)
				(while (/= "SEQEND" (cdr (assoc 0 (entget en))))
					(setq en (entnext en))
					(entmake (entget en '("*")))
				)
				(entdel e)
			))
		)
	)
)
(setq name (entmake '((0 . "ENDBLK"))))
(if name (progn
	(entmake (append 
		'((0 . "INSERT"))
		(list (cons 2 name))
		(list (cons 10 baspoint))
		(list (cons 41 xs))
		(list (cons 42 ys))
		(list (cons 43 zs))
		(list (cons 50 (/ (* PI rot) 180.0)))
	))

))
(if name (entlast) nil)
)


(defun c:makeblock ()
(makeblock (getstring "\nName: ") (getpoint "\nInsertionpoint: ") (ssget) 1 1 1 0 )
)

(princ "\nXSCALE: scales AutoCAD Entities non-uniformly in X-,Y- and Z-direction!")
(prin1) 